﻿using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using static Infragistics.Win.ImageAndTextUIElement;

namespace ColumnChooserImageSize
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ultraGrid1.DisplayLayout.Override.RowSelectorHeaderStyle = RowSelectorHeaderStyle.ColumnChooserButton;
            ultraGrid1.DisplayLayout.Override.RowSelectors = DefaultableBoolean.True;

            ultraGrid1.DisplayLayout.Override.RowSelectorWidth = 50;
            ultraGrid1.DisplayLayout.Bands[0].ColHeaderLines = 3;

            ultraGrid1.CreationFilter = new ColumnChooserButtonCreationFilter();
            ultraGrid1.DisplayLayout.Override.RowSelectorHeaderAppearance.Image = new Bitmap(@"../../Smile.jpg");
        }
    }

    public class ColumnChooserButtonCreationFilter : IUIElementCreationFilter
    {
        public void AfterCreateChildElements(UIElement parent)
        {
            if (parent is ImageAndTextUIElement && parent.Parent is ColumnChooserButtonUIElement)
            {
                UIElement imageElement = parent.GetDescendant(typeof(ImageAndTextDependentImageUIElement));
                (imageElement as ImageAndTextDependentImageUIElement).Scaled = true;
                imageElement.Rect = parent.Rect;
            }
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }
    }
}
